#!/usr/bin/env python2
# Client part of the reference scenario
# See comments in scenario-server.py
from tests.mptcptestlib import *
from tests import mptcptestlib

def main():
    conf = {"printanswer":False, "debug":2, "check": False}
    t = ProtoTester(conf)
    s = MPTCPState()
    m = MPTCPTest(tester=t, initstate=s)

    # Client IPs
    AIP = "192.168.22.132"
    APort = 6698
    #A2 = "10.1.2.2"
    # Server IP
    BIP = "192.168.22.132"
    BPort = 8080

    t.toggleKernelHandling(enable=False)
    try:

#         print "key 1 is: 16728724419308489120"
#         gentoken , gendsn = mptcptestlib.key2tokenAndDSN(16728724419308489120)
#         print "Generated token:", gentoken
#         print "Generated dsn:", gendsn
        sub1 = s.registerNewSubflow(dst=BIP, src=AIP,dport=BPort,sport=APort)


        conn_open = [m.CapSYN, m.Wait, m.CapACK]
        t.sendSequence(conn_open, initstate=s, sub=sub1)
        print "Sent Sequence 1 (conn_open)"

        #get_req = "GET / HTTP/1.1 \r\n" + "Host: " + BIP + "\r\n"+ "\r\n"
        get_req = " GET / HTTP/1.0 \r\n" + "\r\n"
        a=m.send_data_sub(s=s, data=get_req, sub=sub1)

        print "here 2 ?"
        # wait for the ack of the last segment sent
        lastSent = a[-1][0]
        t.sendpkt(m.Wait, sub=sub1 ,waitfct=m.Wait.waitAckForPkt(s,lastSent))
        print "Received Ack"

#TODO: Fix data receipt,ack, and Stream ack and closing

        print "Stream closing details follow"
        data_fin_init = [m.DSSFIN, m.Wait, m.DSSACK, m.Wait]
        t.sendSequence(data_fin_init, sub=sub1)



        # assuming that the remote host uses a single FINACK packet
        fin_init1 = [m.FIN, m.Wait, m.ACK]
        t.sendSequence(fin_init1, sub=sub1)
        t.syncWait() # blocking call for synchronization (slave)
        fin_init2 = [m.FIN, m.Wait, m.ACK]
        t.sendSequence(fin_init2, sub=sub2)
    except PktWaitTimeOutException:
        print("Waiting has timed out, test exiting with failure")
        sys.exit(1)
    finally:
        t.toggleKernelHandling(enable=True)
        pass

if __name__ == "__main__":
    main()
# vim: set ts=4 sts=4 sw=4 et:
