#!/usr/bin/env python2
# Client part of the reference scenario
# See comments in scenario-server.py
from tests.mptcptestlib import *
from tests import mptcptestlib
import time

def main():
    conf = {"printanswer":False, "debug":2, "check": False}
    t = ProtoTester(conf)
    s = MPTCPState()
    m = MPTCPTest(tester=t, initstate=s)
    timeout=5

    # Server IP
    localIP = "192.168.22.132"
    localPort = 8080

    t.toggleKernelHandling(enable=False)
    try:

        t.sendpkt(m.Wait, timeout=100)
        time.sleep(1)

        conn_accept = [m.CapSYNACK, m.Wait]
        t.sendSequence(conn_accept, initstate=s,timeout=timeout)#, sub=sub1)

        sub1=s.getSubflow(0)

        #get_req = "GET / HTTP/1.1 \r\n" + "Host: " + BIP + "\r\n"+ "\r\n"
        get_req = " HELLO HELLO HELLO HELLO HELLO HELLO HELLO" + "\r\n"
        m.send_data_sub(s=s, data=get_req, sub=sub1)


        for i in range (1,100):
            j = 0
            for sflow in s.sub:
                #Do subflow 1
                print "Subflow ", j, " cycling..."
                ackDss=[m.DSSACK]
                t.sendSequence(ackDss, initstate=s, sub=sflow,waitAck=True, timeout=timeout)
                j+= 1
            print " ------- Heartbeat Number", str(i)

        j = 0
        for sflow in s.sub:
            data_fin = [m.DSSFIN, m.DSSACK]
            t.sendSequence(data_fin, initstate=s, sub=sflow, waitAck=True, timeout=timeout)
            print "Subflow ", j, " closed FIN"
            j+= 1


        print "______----------------------------------- finished?? ---------------------"

    except PktWaitTimeOutException:
        print("Waiting has timed out, test exiting with failure")
        sys.exit(1)
    finally:
        t.toggleKernelHandling(enable=True)
        pass

if __name__ == "__main__":
    main()
# vim: set ts=4 sts=4 sw=4 et:
